image: openjdk:8

clone:
  depth: full              # SonarCloud scanner needs the full history to assign issues properly

definitions:
  caches:
    sonar: ~/.sonar/cache  # Caching SonarCloud artifacts will speed up your build
  steps:
    - step: &build-test-sonarcloud
        name: Build, test and analyze on SonarCloud
        caches:
          - maven
          - sonar
        script:
          - /bin/sh mvnw -B org.jacoco:jacoco-maven-plugin:prepare-agent verify org.sonarsource.scanner.maven:sonar-maven-plugin:sonar -Dsonar.java.libraries=**/*.jar
      artifacts:
          - target/
    - step: &build-test
        name: Build and test
        caches:
          - maven
        script:
          - /bin/sh mvnw -B verify
        artifacts:
          - target/**
pipelines:
  default:
    - step: *build-test
  branches:
    master:
      - step: *build-test-sonarcloud
    develop:
      - step: *build-test-sonarcloud
  pull-requests:
    '**':
      - step: *build-test-sonarcloud